package uam.patrones.builder.operaciones;

import java.util.LinkedList;

import uam.patrones.builder.clases.Alumno;
import uam.patrones.builder.clases.Licenciatura;
import uam.patrones.builder.clases.Uea;

public class Builder {

	private String matricula;
	private String nombre;
	private Licenciatura licenciatura;
	private Uea uea;
	private LinkedList<Uea>listaUea;
	
	public Builder() {
		listaUea = new LinkedList<Uea>();
	}
	
	public Builder matricula(String matricula) {
		this.matricula = matricula;
		return this;
	}
	
	public Builder nombre(String nombre) {
		this.nombre = nombre;
		return this;
	}
	
	public Builder licenciatura(String nombre, String clave) {
		licenciatura=new Licenciatura();
		this.licenciatura.setClave(clave);
		this.licenciatura.setNombre(nombre);
		return this;
	}
	
	public Builder uea(String clave, String nombre, int creditos) {
		uea = new Uea();
		this.uea.setClave(clave);
		this.uea.setNombre(nombre);
		this.uea.setCreditos(creditos);
		listaUea.add(uea);
		return this;
	}
	
	public Alumno alumno(Builder builder) {
		
		Alumno alumno = new Alumno();
		alumno.setMatricula(builder.matricula);
		alumno.setNombre(builder.nombre);
		alumno.setLicenciatura(licenciatura);
		alumno.setListaUea(builder.listaUea);
		return alumno;
		
	}
	

	
}
